# Plugins "Comments" cr par BG

# Affiche une fentre avec une zone de texte pour enregistrer l'historique de vos modifications de fichiers
# Ajoute un sous-menu "Afficher/masquer l'historique" dans le menu Plugins pour afficher/cacher la fentre
# L'historique est enregistr dans le fichier SKP

module BGSketchup
	module Comments
		Sketchup::require 'BGSketchup/Comments/Rb/Localization'
		Sketchup::require 'BGSketchup/BGSketchup'
		include BGSketchup
		include BGSketchup_Comments_Localization
		@current_tab=0
		@number_of_tab=1
		@work_in_progress=false
		def self.show_hide_Comments_window
			#On affiche la fentre
				if @my_dialog==nil 
					# On cr la bote de dialogue    
						@my_dialog = UI::WebDialog.new(@strWindowName+" "+BGSketchup_Comments_extension.version, false, nil , 300, 100, 200, 200, true)
					# On affiche la bote de dialogue
						html_path = File.join(DIR, "Comments", "Html", "Comments.html")
						@my_dialog.set_file(html_path)
						@my_dialog.show()
						@my_dialog.set_background_color(@my_dialog.get_default_dialog_color)
						self.load_options_in_html

					# Gestion des actions gnres par la bote de dialogue
						@my_dialog.add_action_callback("get_data") do |web_dialog,action_name|
							if action_name.index("(")!=nil then
								action=action_name[0..action_name.index("(")-1]
								parameter=action_name[action.length+1..action_name.length-2]
								action_name=action
							end
							case action_name
								when "save_comments" then self.save_comments
								when "load_comments" then self.load_comments(parameter)
								when "translation" then self.translation
								when "about" then self.about 
								when "load_options" then self.load_options_in_html
								when "start" then self.start
								when "show_tab" then self.show_tab(parameter.to_i)
								when "add_tab" then self.add_tab(parameter)
								when "delete_tab" then self.delete_tab(parameter.to_i)
								when "appliquerOptions" then self.appliquerOptions(parameter)
							end
						end
				else #Si la fentre est dj affiche
					if @my_dialog.visible? ==false then
						@my_dialog.show()
					else
						@my_dialog.close()
					end
				end      
		end # def
		
		def self.load_comments(tab=0)
			#Load default tab if necessary
				tab='' if (tab==0)
			#Get Comments in Model
				model = Sketchup.active_model 
				value = model.get_attribute "BGSketchup_Comments", "Text"+tab.to_s, ""
			#Update if window exist or options for auto-openning are ok
				self.show_hide_Comments_window if (@my_dialog==nil && (@option_open_window==true || (@option_open_window_if_exist==true && value!="")))
				return nil if @my_dialog==nil
			#Load the Comments
				js = "loadComments('"+ bgSketchup_to_java(value) + "');"
				js+= "document.getElementById('comments').scrollTop=document.getElementById('comments').scrollHeight;" if @option_show_bottom==true
				@my_dialog.execute_script(js)
		end
		def self.save_comments
			if @work_in_progress==false then
				#Get the text
					nom=@my_dialog.get_element_value('comments')
				#Convert feed line
					nom=nom.gsub(10.chr, "<br>").gsub(13.chr,"")
				#Save into Model attributes
					model = Sketchup.active_model
					tab=@current_tab
					tab='' if tab==0
					if (model.get_attribute "BGSketchup_Comments", "Text"+tab.to_s, "")!=nom then
						Sketchup.active_model.start_operation("Comment modification",false,false,true)
							value = model.set_attribute "BGSketchup_Comments", "Text"+tab.to_s, nom
						Sketchup.active_model.commit_operation
					end
			end
		end
		def self.save_current_tab
			#Save current tab
				Sketchup.active_model.set_attribute "BGSketchup_Comments", "CurrentTab",@current_tab
		end
		
		def self.start
			# Get the different tabs
				attrdict = Sketchup.active_model.attribute_dictionaries['BGSketchup_Comments']
				if attrdict!=nil then
					max=0
					attrdict.each_key { | key |
						if key[0..3]="Text" then
							if key!="Text" then					
								ind=key[4..key.length-1].to_i
								if (ind>max) then
									max = ind
								end
							end
						end
					}
					for tab in 0..max
						tab2=tab; tab2='' if tab==0
						name=Sketchup.active_model.get_attribute "BGSketchup_Comments", "TabName"+tab2.to_s, "General"
						if tab==0 then
							@my_dialog.execute_script("document.getElementById('tabText0').innerHTML='"+bgSketchup_to_java(name)+"';") if (name!=nil)
						else
							@my_dialog.execute_script("add_tab('"+bgSketchup_to_java(name)+"',false);") if (name!=nil)
						end
					end
				else #No attribute exist, we create the standard one
					Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabName", "General"
					Sketchup.active_model.set_attribute "BGSketchup_Comments", "Text", ""
					Sketchup.active_model.set_attribute "BGSketchup_Comments", "CurrentTab", 0
				end
			
			self.load_comments(0)
			self.translation
			self.load_options_in_html
			self.show_tab(Sketchup.active_model.get_attribute "BGSketchup_Comments", "CurrentTab",0);
			@my_dialog.execute_script('select_tab('+(Sketchup.active_model.get_attribute "BGSketchup_Comments", "CurrentTab",0).to_s+');')
		end
		
		def self.show_tab(tab)
			save_comments if @current_tab!=tab
			@current_tab=tab
			load_comments(tab)
		end		
		def self.add_tab(number_of_tab)
			name=UI.inputbox(["Enter tab's name : "],["Tab"+number_of_tab.to_s],"Enter the tab's name")
			@my_dialog.execute_script("add_tab('"+bgSketchup_to_java(name[0])+"');") if (name!=nil)
			Sketchup.active_model.start_operation("Comment modification",false,false,true)
				Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabName"+number_of_tab.to_s, name[0]
				Sketchup.active_model.set_attribute "BGSketchup_Comments", "Text"+number_of_tab.to_s, ""
			Sketchup.active_model.commit_operation
			@my_dialog.execute_script("show_tab(document.getElementById('tab"+(@number_of_tab).to_s+"'));")
			@number_of_tab+=1
		end
		def self.delete_tab(tab)
			#Confirmation
				reponse=UI.messagebox "Are you sure to delete this tab ?", MB_YESNO
			#If Yes
				if reponse==6 then
					@work_in_progress=true
					Sketchup.active_model.start_operation("Comment modification",false,false,true)
						#Slice all tabs
							for j in tab..@number_of_tab-1
								i=j; i='' if j==0 #For first tab that is "Text" and not "Text0"
								Sketchup.active_model.set_attribute "BGSketchup_Comments", "TabName"+i.to_s, get_tab_name(j+1)
								Sketchup.active_model.set_attribute "BGSketchup_Comments", "Text"+i.to_s, get_tab_text(j+1)
							end						
						#Delete last tab
							Sketchup.active_model.attribute_dictionaries['BGSketchup_Comments'].delete_key("TabName"+(@number_of_tab).to_s)
							Sketchup.active_model.attribute_dictionaries['BGSketchup_Comments'].delete_key("Text"+(@number_of_tab).to_s)
							@number_of_tab-=1
					Sketchup.active_model.commit_operation
					
					#Graphical deletion in javascript
						@my_dialog.execute_script("delete_Tab("+tab.to_s+");")
					#Load current tab comments
						if tab<=@current_tab then
							UI.messagebox "ok"
							@current_tab-=1;
							if @current_tab==-1 then
								@current_tab=0
							end
						end
						@my_dialog.execute_script("show_tab(document.getElementById('tab"+@current_tab.to_s+"'));")
					@work_in_progress=false
				end
		end
		def self.get_tab_name(tab)
			return Sketchup.active_model.get_attribute"BGSketchup_Comments", "TabName"+tab.to_s, ""
		end
		def self.get_tab_text(tab)
			return Sketchup.active_model.get_attribute"BGSketchup_Comments", "Text"+tab.to_s, ""
		end
		def self.about
			wAbout = UI::WebDialog.new(@strAbout, true,"BGSketchup_Comments_About" , 316, 293, 100, 200, true)
			html_path = File.join(DIR, "Comments", "Html", "About.html")
			wAbout.set_file(html_path)
			wAbout.set_background_color("ffffff")
			wAbout.set_size(400,320)
			wAbout.show_modal { wAbout.execute_script("document.getElementById('version').innerHTML='"+BGSketchup_Comments_extension.version+"';")}
		end
		
		def self.creation_menus
			#Ajout du menu
				menu=BGSketchup_Ajouter_Submenu("BGSketchup")
				menu.add_item(@strWindowName) {self.show_hide_Comments_window }
			#Ajout de la barre d'outil
				@toolbar = UI::Toolbar.new "Comments (BGSketchup)"
				@cmd = UI::Command.new(@strWindowName) { self.show_hide_Comments_window }
				@cmd.small_icon = @cmd.large_icon = File.join(DIR, "Comments", "Html", "Pictures", "Comments-icon.png")
				@cmd.tooltip = @strWindowName
				@cmd.status_bar_text = @strWindowName
				@toolbar.add_item @cmd
		end
		
		def self.translation
			if @my_dialog!=nil then
				js= "liste=document.getElementById('languagelist');"
				js+= "liste.length=0;"
				for i in 0..@availableLanguages.length-1
					js+= "liste.options[liste.length] = new Option('"+@availableLanguagesName[i].to_s+"', '"+@availableLanguages[i].to_s+"');"+13.chr
				end
				for i in 0..@strButtonsTitles.length-1
					js+= "document.getElementById('Btn"+i.to_s+"').title='"+bgSketchup_to_java(@strButtonsTitles[i])+"';"+13.chr
				end
				for i in 0..@strButtonsTexts.length-1
					js+= "document.getElementById('BtnTxt"+i.to_s+"').innerHTML='"+bgSketchup_to_java(@strButtonsTexts[i])+"';"+13.chr
				end
				for i in 0..@strTexts.length-1
					js+= "document.getElementById('txt"+i.to_s+"').innerHTML='"+bgSketchup_to_java(@strTexts[i])+"';"+13.chr
				end
				@my_dialog.execute_script(js)
			end
		end

		def self.save_options
			file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_Comments.ini")
			File.delete(file_name) if File.exists?(file_name)
			file=File.new(file_name, "w")
			file.puts("option_open_window") 
			file.puts(@option_open_window)
			file.puts("option_open_window_if_exist") 
			file.puts(@option_open_window_if_exist)
			file.puts("option_langue") 
			file.puts(@option_langue)
			file.puts("option_show_bottom") 
			file.puts(@option_show_bottom)
			file.close
		end
		def self.load_options
			#Load default option in case one option is missing
			self.load_default_options
			file_name=File.join(BGSketchup::bgSketchup_getTempFolder,"BGSketchup_Comments.ini")
			if File.exists?(file_name)==true then 	#File exist
				file = File.open(file_name, "r")
				while !file.eof?
					option_name=file.readline.gsub(10.chr,"").gsub(13.chr,"")
					option_value=file.readline.gsub(10.chr,"").gsub(13.chr,"")

					@option_langue=option_value if option_name=="option_langue"
					@option_open_window=(option_value=="true") ? true : false if option_name=="option_open_window"
					@option_open_window_if_exist=(option_value=="true") ? true : false if option_name=="option_open_window_if_exist"
					@option_show_bottom=(option_value=="true") ? true : false if option_name=="option_show_bottom"
				end
				file.close
			else												#File doesn't exist
				#Save Default options
				save_options
			end
		end
		def self.load_default_options	#Default options
			@option_langue=Sketchup.os_language
			@option_open_window = false
			@option_open_window_if_exist = true
			@option_show_bottom = true
		end
		def self.load_options_in_html	#Check options
			cb=[]
			cb.push (@option_open_window_if_exist==true) ? "true" : "false"
			cb.push (@option_open_window==true) ? "true" : "false"
			cb.push (@option_show_bottom==true) ? "true" : "false"
			
			js=""
			for i in 0..cb.length-1
				js+= "document.getElementById('cb"+i.to_s+"').checked="+cb[i].to_s+";"
			end
			js+="document.getElementById('languagelist').value='"+@option_langue.to_s+"';"
			@my_dialog.execute_script(js)
		end
		def self.appliquerOptions(options)
			old=@option_langue
			@option_open_window_if_exist=(options[0].chr=='1') ? true : false
			@option_open_window=(options[1].chr=='1') ? true : false
			@option_show_bottom=(options[2].chr=='1') ? true : false
			o=options[4..options.length-1].split(",")
			@option_langue=o[0]
			self.save_options
			if @option_langue!=old then	#Si on change de langue, alors on redmarre l'interface
				@my_dialog.close();@my_dialog=nil
				initialise_localization_BGSketchupComments
				self.show_hide_Comments_window
			end
		end
		
		def self.attach_observers
			Sketchup.add_observer(Comments::MyAppObserver.new)
			Sketchup.active_model.add_observer(Comments::MyModelObserver.new)
		end
		class MyAppObserver < Sketchup::AppObserver
			def onNewModel(model)
				Comments::start
				Sketchup.active_model.add_observer(Comments::MyModelObserver.new)
			end
			def onOpenModel(model)
				Comments::start
				Sketchup.active_model.add_observer(Comments::MyModelObserver.new)
			end
		end
		class MyModelObserver < Sketchup::ModelObserver
			def onPreSaveModel(model)
				Comments::save_current_tab
			end
		end
		unless file_loaded?( __FILE__ )
			self.load_options
			initialise_localization_BGSketchupComments
			self.creation_menus
			#self.load_options
			self.attach_observers
			self.load_comments(0)
		end
		file_loaded(__FILE__)
	end #module Comments
end #module BGSketchup
